local TAG = "sandbox"

local AimStrategy = luajava.bindClass(GNS .. "Tower$AimStrategy")

local setupListener
local disposeListener

local sp
sp = scenarioPlayer:new()

-- Сценарий -----------------------------------
--[[
sp:addAction(0, function() -- Выполняется сразу (прошло 0 секунд)
    -- Выдаем много монет
    cmd.coins(100000)
    -- Показываем уведомление с подсказкой
    managers.UiManager.notifications:add("Press P or switch game speed to start the script", nil, nil, nil)
    -- Ставим игру на паузу - следующие действия не будут выполнены, пока игра не будет снята с паузы (время остановлено на 0)
    cmd.setgamespeed(0)
end)

sp:addAction(0.1, function() -- Выполняется через 0.1 секунд (почти сразу, как только игра была снята с паузы)
    -- Прячем интерфейс
    cmd.hideui()

    local Interpolation = luajava.bindClass("com.badlogic.gdx.math.Interpolation")
    systems.InputSystem.cameraController:animate(128, 256, 2.0, 0.5, Interpolation.linear)
end)

sp:addAction(5, function() -- Через 5 секунд
    -- С интервалом в 0.15 секунд добавляем врагов на все тайлы в первом ряду карты, повторяем 100 раз
    sp:addInterval(0.15, function()
        for y = 0, 22 do -- От низу к верху, проходим по всем платформам и спавним врага
            cmd.addenemy(enums.EnemyType.REGULAR, 1, 100, 1, 1000, 1000, 0, y, -1)
        end
    end, 100, nil)
end)

-- ... и т.д.
--]]

local enemySystemListener = luajava.createProxy(GNS .. "systems.EnemySystem$EnemySystemListener", {
    enemyDie = function(enemy, tower, damageType, fromAbility)
        local explosion = managers.ExplosionManager:getFactory(enums.ExplosionType.CANNON):obtain();

        explosion:setup(tower, enemy.position.x, enemy.position.y, enemy.maxHealth, 2, 0)
        systems.ExplosionSystem:register(explosion)
        explosion:explode()
    end,

    affectsGameState = function() return true end,
    getConstantId = function() return 1000901 end
})

-- Конец сценария -----------------------------------

local updateListener = function(deltaTime)
    sp:update(deltaTime)
end

setupListener = function()
    addEventHandler("SystemUpdate", updateListener)
    addEventHandler("SystemDispose", disposeListener)

    systems.EnemySystem.listeners:add(enemySystemListener)
end

disposeListener = function()
    removeEventHandler("SystemUpdate", updateListener)
    removeEventHandler("SystemPostSetup", setupListener)
    removeEventHandler("SystemDispose", disposeListener)

    systems.EnemySystem.listeners:remove(enemySystemListener)
end

addEventHandler("SystemPostSetup", setupListener)